<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';

import { getPageMetadata } from '~/common/meta';
import { LivePreviewMixin } from '~/mixins';
import { ContentfulLivePreview } from '@contentful/live-preview';
import { SolutionsService } from '~/services';
import IndustryTemplate from '~/components/solutions/templates/industry-template.vue';

export default Vue.extend({
  components: { IndustryTemplate },
  mixins: [LivePreviewMixin],
  nuxtI18n: false,
  async asyncData({ $solutionsService, params }: any) {
    try {
      const { items, solutions: earlyAccess } = await (<SolutionsService>(
        $solutionsService
      )).getContent(
        `community/early-access${params.slug ? `/${params.slug}` : ''}`,
        !params.slug,
      );

      return { items, earlyAccess };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).earlyAccess, this.$route.path);
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items,
        callback: (updatedData) =>
          (this.earlyAccess =
            this.$solutionsService.transformContentfulData(updatedData)),
      });

      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
});
</script>

<template>
  <industry-template :solutions="earlyAccess" />
</template>
